org.eclipse.microprofile.openapi.models.servers

## Interface Server

All Superinterfaces:
  Constructible, Extensible<Server>

    public interface Server
    extends Constructible, Extensible<Server>

An object representing a server.

See Also:
  Server Object

### Method Summary

All Methods Instance Methods Abstract Methods Default Methods
`Server` `addVariable(String variableName, ServerVariable variable)` Adds the given server variable item to the Server's map of variables.
`default Server` `description(String description)` This method sets the description property of a Server instance to the given description parameter and returns the modified instance.
`String` `getDescription()` This method returns the description property of Server instance.
`String` `getUrl()` This method returns the url property of Server instance, which is a URL to the target host.
`Map<String,ServerVariable>` `getVariables()` This method returns the variables property of Server instance.
`void` `removeVariable(String variableName)` Removes the given server variable item from the Server's map of variables
`void` `setDescription(String description)` This method sets the description property of a Server instance to the given description parameter.
`void` `setUrl(String url)` This method sets the url property of Server instance to the given url argument, representing a URL to the target host.
`void` `setVariables(Map<String,ServerVariable> variables)` This method sets the variables property of Server instance to the given variables argument.
`default Server` `url(String url)` This method sets the url property of Server instance to the given url argument, representing a URL to the target host, and returns the modified instance.
`default Server` `variables(Map<String,ServerVariable> variables)` This method sets the variables property of Server instance to the given variables argument and returns the modified instance.

### Methods inherited from interface org.eclipse.microprofile.openapi.models.Extensible

`addExtension, extensions, getExtensions, removeExtension, setExtensions`

### Method Detail

#### getUrl

    String getUrl()

This method returns the url property of Server instance, which is a URL to the target host.

This URL supports Server Variables and MAY be relative, to indicate that the host location is relative to the location where the OpenAPI definition is being served. Variable substitutions will be made when a variable is named enclosed in curly brackets.

This is a REQUIRED property.

Returns:
  String url

#### setUrl

    void setUrl(String url)

This method sets the url property of Server instance to the given url argument, representing a URL to the target host.

This URL supports Server Variables and MAY be relative, to indicate that the host location is relative to the location where the OpenAPI definition is being served. Variable substitutions will be made when a variable is named enclosed in curly brackets.

This is a REQUIRED property.

Parameters:
  `url` - a URL to the target host

#### url

    default Server url(String url)

This method sets the url property of Server instance to the given url argument, representing a URL to the target host, and returns the modified instance.

This URL supports Server Variables and MAY be relative, to indicate that the host location is relative to the location where the OpenAPI definition is being served. Variable substitutions will be made when a variable is named enclosed in curly brackets.

This is a REQUIRED property.

Parameters:
  `url` - a URL to the target host
Returns:
  Server instance with the set url property.

#### getDescription

    String getDescription()

This method returns the description property of Server instance. The decsription property is an optional string describing the host designated by the URL.

Returns:
  String description

#### setDescription

    void setDescription(String description)

This method sets the description property of a Server instance to the given description parameter.

Description of a server is an optional string describing the host designated by the URL. CommonMark syntax can be used for rich text representation.

Parameters:
  `description` - an optional string describing the host designated by the URL

#### description

    default Server description(String description)

This method sets the description property of a Server instance to the given description parameter and returns the modified instance.

Description of a server is an optional string describing the host designated by the URL. CommonMark syntax can be used for rich text representation.

Parameters:
  `description` - an optional string describing the host designated by the URL
Returns:
  Server instance with the set description property.

#### getVariables

    Map<String,ServerVariable> getVariables()

This method returns the variables property of Server instance.

Variables are represented as a map between variable name and its value. The value is used for substitution in the server's URL template.

Returns:
  map of server variables (potentially immutable).

#### addVariable

    Server addVariable(String variableName,
                       ServerVariable variable)

Adds the given server variable item to the Server's map of variables.

Parameters:
  `variableName` - the name the variable to add
  `variable` - a server variable used for substitution in the server's URL template.
Returns:
  the current Server object

#### removeVariable

    void removeVariable(String variableName)

Removes the given server variable item from the Server's map of variables

Parameters:
  `variableName` - the name the variable to remove

#### setVariables

    void setVariables(Map<String,ServerVariable> variables)

This method sets the variables property of Server instance to the given variables argument.

Variables property is a map between variable name and its value. The value is used for substitution in the server's URL template.

Parameters:
  `variables` - a map between variable name and its value

#### variables

    default Server variables(Map<String,ServerVariable> variables)

This method sets the variables property of Server instance to the given variables argument and returns the modified instance.

Variables property is a map between variable name and its value. The value is used for substitution in the server's URL template.

Parameters:
  `variables` - a map between variable name and its value
Returns:
  Server instance with the set variables property.